/*
 Do not modify, auto-generated by model_gen.tcl

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   clocked_seq.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_CLOCKED_SEQ_H
#define UHDM_CLOCKED_SEQ_H

#include "SymbolFactory.h"
#include "BaseClass.h"
#include "containers.h"
#include "uhdm.h"

namespace UHDM {

  class clocked_seq : public BaseClass {
  public:
    // Implicit constructor used to initialize all members,
    // comment: clocked_seq();
    virtual ~clocked_seq() final {}
    
    virtual const BaseClass* VpiParent() const final { return vpiParent_; }

    virtual bool VpiParent(BaseClass* data) final { vpiParent_ = data; if (data) uhdmParentType_ = data->UhdmType(); return true;}

    virtual unsigned int UhdmParentType() const final { return uhdmParentType_; }

    virtual bool UhdmParentType(unsigned int data) final { uhdmParentType_ = data; return true;}

    virtual bool VpiFile(const std::string& data) final;

    virtual const std::string& VpiFile() const final;

    unsigned int UhdmId() const { return uhdmId_; }

    bool UhdmId(unsigned int data) { uhdmId_ = data; return true;}

    clocked_seq* DeepClone(Serializer* serializer, ElaboratorListener* elab_listener, BaseClass* parent) const override;

    const expr* VpiClockingEvent() const { return vpiClockingEvent_; }

    bool VpiClockingEvent(expr* data) { vpiClockingEvent_ = data; return true;}

    const any* VpiSequenceExpr() const { return vpiSequenceExpr_; }

    bool VpiSequenceExpr(any* data) {if (!sequence_expr_groupGroupCompliant(data)) return false; vpiSequenceExpr_ = data; return true;}

    unsigned int VpiType() const final { return vpiClockedSeq; }

   virtual  UHDM_OBJECT_TYPE UhdmType() const final { return uhdmclocked_seq; }   
  private:
    
    BaseClass* vpiParent_ = nullptr;

    unsigned int uhdmParentType_ = 0;

    SymbolFactory::ID vpiFile_ = 0;

    unsigned int uhdmId_ = 0;

    expr* vpiClockingEvent_ = nullptr;

    any* vpiSequenceExpr_ = nullptr;

  };

  
  class clocked_seqFactory {
  friend Serializer;
  public:
  clocked_seq* Make() {
    clocked_seq* obj = new clocked_seq();
    objects_.push_back(obj);
    return obj;
  }
  private:
    std::vector<clocked_seq*> objects_;
  };
  
  
  class VectorOfclocked_seqFactory {
  friend Serializer;
  public:
  std::vector<clocked_seq*>* Make() {
    std::vector<clocked_seq*>* obj = new std::vector<clocked_seq*>();
    objects_.push_back(obj);
    return obj;
  }
  private:
  std::vector<std::vector<clocked_seq*>*> objects_;
  };

};

#endif
